#ifndef __DOTSCARA_HEADER_INCLUDED__
#define __DOTSCARA_HEADER_INCLUDED__

#include <sys/types.h>

#if __GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 1)
#define __private __attribute__((visibility("hidden")))
#else
#define __private
#endif

#ifdef __WIN32__
#define __public __declspec(dllexport)
#else
#define __public
#endif

#ifdef __GNUC__
#define __noreturn __attribute__((noreturn))
#define __purefn __attribute__((pure))
#define __printf(x,y) __attribute__((format(printf,x,y)))
#if __GNUC__ > 2
#define __nonull(x...) __attribute__((nonnull (x)))
#define __constfn __attribute__((const))
#define __malloc __attribute__((malloc))
#endif
#endif

#ifndef __noreturn
#define __noreturn
#endif

#ifndef __purefn
#define __purefn
#endif

#ifndef __printf
#define __printf(x,y)
#endif

#ifndef __nonull
#define __nonull(x...)
#endif

#ifndef __malloc
#define __malloc
#endif

#ifndef __constfn
#define __constfn
#endif

#if __GNUC__ > 3 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 96 )
#define likely(x) __builtin_expect(!!(x), 1)
#define unlikely(x) __builtin_expect(!!(x), 0)
#else
#define likely(x) x
#define unlikely(x) x
#endif

#define BITMASK_ANY (-1UL)
typedef unsigned long bitmask_t;

#endif /* __DOTSCARA_HEADER_INCLUDED__ */
