/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2002,2003,2004 Gianni Tedesco <gianni@scaramanga.co.uk>
 * This program is released under the terms of the GNU GPL version 2
*/
#ifndef __STRTOUINT_HEADER_INCLUDED__
#define __STRTOUINT_HEADER_INCLUDED__

/* Error detecting string to unsigned int conversion.
*  Return values:
*   <0 - error
*   =0 - the input string was perfect
*   >0 - the input string had trailing garbage, return
*        value tells you how many bytes were numbers.
*/
int strtouint(const char *s, unsigned int *v) __nonull(1,2);

/* String to IP number conversion
 * Return values:
 *  0 - error
 *  non-0 - OK
*/
int strtoip(const char *s, u_int32_t *ip) __nonull(1,2);

/* Static buffer */
const char *iptostr(u_int32_t ip);

#endif /* __STRTOUINT_HEADER_INCLUDED__ */
