/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2002,2003,2004 Gianni Tedesco <gianni@scaramanga.co.uk>
 * This program is released under the terms of the GNU GPL version 2
*/
#ifndef __TARGET_HEADER_INCLUDED__
#define __TARGET_HEADER_INCLUDED__

typedef int(*proc_target)(struct packet *, void *);
typedef int(*proc_target_validate)(const char *, void **);
typedef int(*proc_target_cleanup)(void *);

struct target {
	struct target		*next;
	const char		*name;
	const char		*desc;
	proc_target		target;
	proc_target_validate	validate;
	proc_target_cleanup	cleanup;
	struct arg		*args;
};

struct target *target_find(const char *);
void target_load(void);

#endif /* __TARGET_HEADER_INCLUDED__ */
